<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/AVSCommon/Utils/include/AVSCommon/Utils/Configuration/ConfigurationNode.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_13e65effb2bde530b17b3d5eefcd0266.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_49dd3d9ac5586189aa170bac46425b9c.html">Utils</a></li><li class="navelem"><a class="el" href="dir_957fc395b73dfe8b64ee3f74464f588a.html">include</a></li><li class="navelem"><a class="el" href="dir_ced5fe410515ed61d81f9a22ef3eef03.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_ee116be5d1129358ffaec72096859541.html">Utils</a></li><li class="navelem"><a class="el" href="dir_afaa3f3d841804ab5aeaebc7aa06ead7.html">Configuration</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ConfigurationNode.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_configuration_node_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_CONFIGURATION_CONFIGURATIONNODE_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_CONFIGURATION_CONFIGURATIONNODE_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;cstddef&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;rapidjson/document.h&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span>avsCommon {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span>utils {</div><div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration.html">   32</a></span>&#160;<span class="keyword">namespace </span>configuration {</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">   70</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">ConfigurationNode</a> {</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a2d4525fe0433c5ecc68473868da14834">initialize</a>(<span class="keyword">const</span> std::vector&lt;std::shared_ptr&lt;std::istream&gt;&gt;&amp; jsonStreams);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#ab0e1ced7faffb2d9e327e547c3397b01">uninitialize</a>();</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keyword">static</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">ConfigurationNode</a> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a0039cd7a7d88ea973326b38ff611338a">getRoot</a>();</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a4b7dc2a71337e560344143b282fee2ea">ConfigurationNode</a>();</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a5c4c0cff99afe6dfb71b2b8dfc981d6a">getBool</a>(<span class="keyword">const</span> std::string&amp; key, <span class="keywordtype">bool</span>* out = <span class="keyword">nullptr</span>, <span class="keywordtype">bool</span> defaultValue = <span class="keyword">false</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a55d985f4dc3264f4a77931ef1719875e">getInt</a>(<span class="keyword">const</span> std::string&amp; key, <span class="keywordtype">int</span>* out = <span class="keyword">nullptr</span>, <span class="keywordtype">int</span> defaultValue = 0) <span class="keyword">const</span>;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a0cc62d297901ceecc4296f8149e52dcc">getString</a>(<span class="keyword">const</span> std::string&amp; key, std::string* out = <span class="keyword">nullptr</span>, std::string defaultValue = <span class="stringliteral">&quot;&quot;</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> InputType, <span class="keyword">typename</span> OutputType, <span class="keyword">typename</span> DefaultType&gt;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#ab057f5ef302f74345993031cb22d0802">getDuration</a>(</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keyword">const</span> std::string&amp; key,</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        OutputType* out = static_cast&lt;std::chrono::seconds&gt;(0),</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        DefaultType defaultValue = std::chrono::seconds(0)) <span class="keyword">const</span>;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">ConfigurationNode</a> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a7a7f66bf8a0eb3c402fbd52833f96819">operator[]</a>(<span class="keyword">const</span> std::string&amp; key) <span class="keyword">const</span>;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <span class="keyword">operator</span> bool() <span class="keyword">const</span>;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Type&gt;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a738a358705a3d2e11135bdd11d37b55b">getValue</a>(</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keyword">const</span> std::string&amp; key,</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        Type* out,</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        Type defaultValue,</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keywordtype">bool</span> (rapidjson::Value::*isType)() <span class="keyword">const</span>,</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        Type (rapidjson::Value::*getType)() <span class="keyword">const</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    std::string <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a50370edb2cba067f0c91371bb6757006">serialize</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">ConfigurationNode</a> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#ae790c2b186d1cb20ca405749c24c7d21">getArray</a>(<span class="keyword">const</span> std::string&amp; key) <span class="keyword">const</span>;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    std::size_t <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a8fb668ba20176b4bd261e8abe870e1df">getArraySize</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">ConfigurationNode</a> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a7a7f66bf8a0eb3c402fbd52833f96819">operator[]</a>(<span class="keyword">const</span> std::size_t <a class="code" href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">index</a>) <span class="keyword">const</span>;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a4b7dc2a71337e560344143b282fee2ea">ConfigurationNode</a>(<span class="keyword">const</span> rapidjson::Value* <span class="keywordtype">object</span>);</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a0cc62d297901ceecc4296f8149e52dcc">getString</a>(<span class="keyword">const</span> std::string&amp; key, <span class="keyword">const</span> <span class="keywordtype">char</span>** out, <span class="keyword">const</span> <span class="keywordtype">char</span>* defaultValue) <span class="keyword">const</span>;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keyword">const</span> rapidjson::Value* m_object;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;    <span class="keyword">static</span> std::mutex m_mutex;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    <span class="keyword">static</span> rapidjson::Document m_document;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <span class="keyword">static</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">ConfigurationNode</a> m_root;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;};</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> InputType, <span class="keyword">typename</span> OutputType, <span class="keyword">typename</span> DefaultType&gt;</div><div class="line"><a name="l00264"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#ab057f5ef302f74345993031cb22d0802">  264</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#ab057f5ef302f74345993031cb22d0802">ConfigurationNode::getDuration</a>(<span class="keyword">const</span> std::string&amp; key, OutputType* out, DefaultType defaultValue)<span class="keyword"> const </span>{</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="keywordtype">int</span> temp;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="keyword">auto</span> result = <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a55d985f4dc3264f4a77931ef1719875e">getInt</a>(key, &amp;temp);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <span class="keywordflow">if</span> (out) {</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        *out = OutputType(result ? InputType(temp) : defaultValue);</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    }</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <span class="keywordflow">return</span> result;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;}</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> Type&gt;</div><div class="line"><a name="l00274"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a738a358705a3d2e11135bdd11d37b55b">  274</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a738a358705a3d2e11135bdd11d37b55b">ConfigurationNode::getValue</a>(</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="keyword">const</span> std::string&amp; key,</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    Type* out,</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    Type defaultValue,</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <span class="keywordtype">bool</span> (rapidjson::Value::*isType)() <span class="keyword">const</span>,</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    Type (rapidjson::Value::*getType)() <span class="keyword">const</span>)<span class="keyword"> const </span>{</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    <span class="keywordflow">if</span> (key.empty() || !m_object) {</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        <span class="keywordflow">if</span> (out) {</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            *out = defaultValue;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        }</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    }</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    <span class="keyword">auto</span> it = m_object-&gt;FindMember(key.c_str());</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordflow">if</span> (m_object-&gt;MemberEnd() == it || !(it-&gt;value.*isType)()) {</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        <span class="keywordflow">if</span> (out) {</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;            *out = defaultValue;</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        }</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    }</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="keywordflow">if</span> (out) {</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        *out = (it-&gt;value.*getType)();</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    }</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;}</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;}  <span class="comment">// namespace configuration</span></div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;}  <span class="comment">// namespace utils</span></div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;}  <span class="comment">// namespace avsCommon</span></div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_CONFIGURATION_CONFIGURATIONNODE_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode</a></div><div class="ttdef"><b>Definition:</b> ConfigurationNode.h:70</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_ab0e1ced7faffb2d9e327e547c3397b01"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#ab0e1ced7faffb2d9e327e547c3397b01">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::uninitialize</a></div><div class="ttdeci">static void uninitialize()</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:127</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a4b7dc2a71337e560344143b282fee2ea"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a4b7dc2a71337e560344143b282fee2ea">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::ConfigurationNode</a></div><div class="ttdeci">ConfigurationNode()</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:137</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a5c4c0cff99afe6dfb71b2b8dfc981d6a"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a5c4c0cff99afe6dfb71b2b8dfc981d6a">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::getBool</a></div><div class="ttdeci">bool getBool(const std::string &amp;key, bool *out=nullptr, bool defaultValue=false) const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:140</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a738a358705a3d2e11135bdd11d37b55b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a738a358705a3d2e11135bdd11d37b55b">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::getValue</a></div><div class="ttdeci">bool getValue(const std::string &amp;key, Type *out, Type defaultValue, bool(rapidjson::Value::*isType)() const, Type(rapidjson::Value::*getType)() const) const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.h:274</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a0cc62d297901ceecc4296f8149e52dcc"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a0cc62d297901ceecc4296f8149e52dcc">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::getString</a></div><div class="ttdeci">bool getString(const std::string &amp;key, std::string *out=nullptr, std::string defaultValue=&quot;&quot;) const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:148</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test_html_a7b86e4ce414fe200671d6b2f13f570a7"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">alexaClientSDK::mediaPlayer::android::test::index</a></div><div class="ttdeci">static int index</div><div class="ttdoc">Mock buffer index. </div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueueTest.cpp:70</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a50370edb2cba067f0c91371bb6757006"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a50370edb2cba067f0c91371bb6757006">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::serialize</a></div><div class="ttdeci">std::string serialize() const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:179</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a0039cd7a7d88ea973326b38ff611338a"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a0039cd7a7d88ea973326b38ff611338a">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::getRoot</a></div><div class="ttdeci">static ConfigurationNode getRoot()</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:133</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a2d4525fe0433c5ecc68473868da14834"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a2d4525fe0433c5ecc68473868da14834">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::initialize</a></div><div class="ttdeci">static bool initialize(const std::vector&lt; std::shared_ptr&lt; std::istream &gt;&gt; &amp;jsonStreams)</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:93</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a8fb668ba20176b4bd261e8abe870e1df"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a8fb668ba20176b4bd261e8abe870e1df">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::getArraySize</a></div><div class="ttdeci">std::size_t getArraySize() const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:212</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_ae790c2b186d1cb20ca405749c24c7d21"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#ae790c2b186d1cb20ca405749c24c7d21">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::getArray</a></div><div class="ttdeci">ConfigurationNode getArray(const std::string &amp;key) const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:196</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_ab057f5ef302f74345993031cb22d0802"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#ab057f5ef302f74345993031cb22d0802">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::getDuration</a></div><div class="ttdeci">bool getDuration(const std::string &amp;key, OutputType *out=static_cast&lt; std::chrono::seconds &gt;(0), DefaultType defaultValue=std::chrono::seconds(0)) const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.h:264</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a55d985f4dc3264f4a77931ef1719875e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a55d985f4dc3264f4a77931ef1719875e">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::getInt</a></div><div class="ttdeci">bool getInt(const std::string &amp;key, int *out=nullptr, int defaultValue=0) const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:144</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html_a7a7f66bf8a0eb3c402fbd52833f96819"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html#a7a7f66bf8a0eb3c402fbd52833f96819">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode::operator[]</a></div><div class="ttdeci">ConfigurationNode operator[](const std::string &amp;key) const</div><div class="ttdef"><b>Definition:</b> ConfigurationNode.cpp:161</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
